#include <stdio.h>
#include <stdlib.h>

#define infile "galerii.in"
#define outfile "galerii.out"
#define max_n 100

struct slink
{
	int v;
	struct slink *next,*prev,*sym;
};

struct snode
{
	int a,b,d;
};

/*
a -- multimea careia ii apartine
b -- tipul virfului
d -- numarul de muchii ne-parcurse ale virfului
*/

FILE *f;
int m,n,b=0;
struct slink *r[max_n],*re[max_n];						
struct snode v[max_n];
int c[max_n];
short int x=1;

void add_slink(int v1,int v2)
{
	struct slink *t=(struct slink*)malloc(sizeof(struct slink));

	t->v=v2;
	t->next=r[v1];
	t->prev=NULL;
	if (r[v1]) r[v1]->prev=t; else re[v1]=t;

	r[v1]=t;
	v[v1].d++;

	t=(struct slink*)malloc(sizeof(struct slink));

	t->v=v1;
	t->next=r[v2];
    t->prev=NULL;
	if (r[v2]) r[v2]->prev=t; else re[v2]=t;

	r[v2]=t;
	v[v2].d++;

	r[v2]->sym=r[v1];
	r[v1]->sym=r[v2];
}	

void pinit()
{
	int i;
	
	for (i=0;i<max_n;i++)
	{
		re[i]=r[i]=NULL;		
		v[i].a=v[i].d=0;
		v[i].b=-1;
	}
}

void pread()
{
	int i,v1,v2;
	
	f=fopen(infile,"rt");

	fscanf(f,"%i%i",&m,&n);

	for (i=0;i<m;i++)
	{
		fscanf(f,"%i%i",&v1,&v2);

		v1--;
		v2--;

		add_slink(v1,v2);
	}

	fclose(f);
}

void psplit(int v1)
{
	struct slink *t=r[v1];

	v[v1].a=1;

	while (t) 
	{
		if (!v[t->v].a) psplit(t->v);
		t=t->next;
	}
}

int plocate1()
{
	int i;

	for (i=0;i<n;i++)
		if (v[i].d==1) break;

	return i;
}

int plocate2()
{
	int i;

	for (i=0;i<n;i++)
		if (v[i].b==-1) break;

	return i;
}

void pshiftup(int v1,struct slink *s)
{
	if (!s->prev) return;

	s->prev->next=s->next;
	if (s->next) s->next->prev=s->prev;
	if (s==re[v1]) re[v1]=s->prev;
	
    s->next=r[v1];
	s->prev=NULL;
	r[v1]->prev=s;
	r[v1]=s;
}

void pupdate(int v1,int b)
{
	v[v1].b=b;
	v[v1].d--;

	if (v[v1].d>=0)
	{
		v[re[v1]->v].d--;
		pshiftup(re[v1]->v,re[v1]->sym);    
	}
}

short int psametype(int v1,int v2)
{
	struct slink *s,*t;

	s=r[v1];
	t=r[v2];

	while (s && t)
	{
		if (v[s->v].b!=v[t->v].b) return 0;
		 
		s=s->next;
		t=t->next;
	}

    if (s || t) return 0; else return 1;
}

short int pparc(int v1)
{
	int i,n1=1,n2=0;

	pupdate(v1,b);

	for (i=v1+1;i<n;i++)
		if (v[i].a==v[v1].a && v[i].d==v[v1].d+1 && psametype(i,v1))
	{
		pupdate(i,b);
		n1++;
	}

	for (i=v1+1;i<n;i++)
		if (v[i].a!=v[v1].a && v[i].d==v[v1].d+1 && psametype(i,v1))
	{
		pupdate(i,b);
		n2++;
	}

	b++;
	if (n1==n2) return 1; else return 0;
}

void pproc()
{
	int v1=0;

	psplit(0);

	while ((v1<n) && x)
	{
		v1=plocate1();
		if (v1<n) x=pparc(v1);
	}

	if (x)
	{
		v1=plocate2();
		x=pparc(v1);
	}
}

void psavemorph(int v1,int v2)
{
	struct slink *s=r[v1],*t=r[v2];
	
	v[v1].d=v[v2].d=-1;

	fprintf(f,"\n%i %i",v1+1,v2+1);

	while (s && t)
	{
		if (v[s->v].d>-1 && v[t->v].d>-1)
			psavemorph(s->v,t->v);

		s=s->next;
		t=t->next;
	}
}

void psave()
{
	int i,j;

	f=fopen(outfile,"wt");

	fprintf(f,"%i",x);

	if (x) 
	{
		for (i=0;i<n;i++)
			if (v[i].a==0 && v[i].d==-1)
				break;

		for (j=0;j<n;j++)
			if (v[j].a==1 && v[j].d==-1)
				break;

		psavemorph(i,j);
	}

	fclose(f);
}

void main()
{
	pinit();

	pread();
	pproc();
	psave();
}