{Determinam succesiv poligoanele Voronoi, prin intersectii de semiplane}

program Voronoi;
const NMaxPosturi = 250;
type  Post = 1 .. NMaxPosturi;
      Poligon = ^Varf; {lista simplu inlantuita circulara a varfurilor sale, in sens trigonometric}
      Varf = record
             a, o: real; {coordonatele carteziene ale varfului}
             urm: Poligon;
             {adresa urmatorului varf al poligonului in sens trigonometric}
             end;
var n, i, j: Post; p: Poligon;
    x, y: array [Post] of real; {coordonatele posturilor de televiziune}
    l, h: real; fout: text;
    nume:string;

procedure Citire;
var fin: text; i: Post; nume: string;
begin
write (' nume fisier? '); readln(nume);
assign (fin, nume); reset (fin);
readln (fin, n);
for i := 1 to n do readln (fin, x[i], y[i]);
readln (fin, l, h);
close (fin);
end;

function InitPoligon: Poligon;
var p: array [1 .. 4] of Poligon; i: byte;
    dx, dy: array[1 .. 4] of real;
begin
dx[1] := 0; dx[2] :=l; dx [3] := l; dx[4] := 0;
dy[1] := 0; dy[2] := 0; dy[3] := h; dy[4] := h;
for i := 1 to 4 do
    begin
    new(p[i]);
    p[i]^.a := dx[i]; p[i]^.o := dy[i];
    end;
for i := 1 to 3 do  p[i]^.urm := p[i + 1]; p[4]^.urm := p[1];
InitPoligon := p[1];
end;

function Latura (p, q: Poligon): real;
begin
Latura := sqrt (sqr (p^. a - q^. a) + sqr (p^.o - q^.o));
end;

function Arie (p: Poligon): real;
{calculeaza aria poligonului p, prin triangulizare}
var q: Poligon; aa, l1, l2, l3, sp: real;
begin
q := p^.urm; aa := 0;
while q^.urm <> p do
      begin
      l1 := Latura (p, q); l2 := Latura (p, q^.urm); l3 := Latura (q, q^.urm);
      sp := (l1 + l2 + l3) / 2; {semiperimetrul}
      aa := aa + sqrt ( sp * (sp - l1) * (sp - l2) * (sp - l3));
      {am adaugat aria triunghiului (p, q, q^.urm), calculata cu formula lui Heron}
      q := q^.urm;
      end;
Arie := aa;
end;

function AcelasiSemiplan (cx, cy, tl: real; i: Post; q: Poligon): boolean;
{intoarce true daca si numai daca postul i si varful q sunt de aceeasi parte
a dreptei cx * x + cy * y + tl = 0}
begin
AcelasiSemiplan := (cx * x[i] + cy * y[i] + tl) * (cx * q^.a + cy * q^.o + tl) > 0
end;

procedure Mediatoare (i, j: Post; var cx, cy, tl: real);
{calculeaza coeficientii ecuatiei mediatoarei segmentului [Pi, Pj]}
var xm, ym, m: real;
begin
xm := (x[i] + x[j]) / 2; ym := (y[i] + y[j]) / 2;
if x[i] = x[j] then
   begin cx := 0; cy := 1; tl := -ym end
   else
   if y[i] = y[j] then
      begin cx := 1; cy := 0; tl := -xm end
      else
      begin
      m := (x[j] - x[i]) / (y[i] - y[j]);  {panta mediatoarei}
      cx := m; cy := -1; tl := ym - m * xm;
      end;
end;

procedure IntS_M (cx, cy, tl: real; q: Poligon; var xi, yi: real; var nr: byte);
{mareste valoarea parametrului nr cu 1 daca si numai daca si numai daca
mediatoarea (cx, cy, tl) intersecteaza segmentul [q, q^.urm).
{xi, yi sunt coordonatele punctului de intersectie, daca acesta exista}
var d1, d2, d3, det, alfa: real;
    {d1, d2, d3 coeficientii dreptei determinate de varfurile q si q^.urm}
begin
d1 := q^.urm^.o - q^.o;
d2 := q^.a - q^.urm^.a;
d3 := q^.o * (q^.urm^.a - q^.a) - q^.a * (q^.urm^.o - q^.o);
det := cx * d2 - cy * d1;
if det <> 0 then
   begin
   xi := (-tl * d2 + d3 * cy) / det;
   yi := (-cx * d3 + d1 * tl) / det;
   if q^.a = q^.urm^.a then
      alfa := (yi - q^.o) / (q^.urm^.o - q^.o)
      else
      alfa := (xi - q^.a) / (q^.urm^.a - q^.a);
   if (alfa >= 0) and (alfa < 1) then inc (nr);
   end
end;

procedure Intersect (var p: Poligon; i, j: Post);
var xi, yi, xi1, xi2, yi1, yi2, cx, cy, tl: real;
    q1, q2, p1, p2, q: Poligon; nr: byte;
begin
{calculez coeficientii ecuatiei mediatoarei segmentului [Pi, Pj]}
Mediatoare (i, j, cx, cy, tl);
q := p; nr := 0;
repeat
      {determin intersectia segmentului determinat de varfurile [q, q^urm)
      cu mediatoarea segmentului (Pi, Pj)}
      IntS_M (cx, cy, tl, q, xi, yi, nr);
      if nr = 1 then
         begin   {primul punct de intersectie}
         q1 := q;
         xi1 := xi; yi1 := yi; nr := 2;
         end
         else
         if nr = 3 then  {al doilea punct de intersectie}
            begin
            q2 := q;
            xi2 := xi; yi2 := yi; nr := 4;
            end;
      q := q^.urm;
until q = p;
if nr = 4 then  {exista doua puncte de intersectie}
   begin
   { (xi1, yi1), respectiv (xi2, yi2) reprezinta coordonatele punctelor de
   intersectie, iar q1, respectiv q2 reprezinta prima extremitate a laturilor poligonului
   intersectate de mediatoare}
   if not AcelasiSemiplan (cx, cy, tl, i, q1^.urm) then
      begin
      {retin partea "din stanga"}
      new (p2); p2^.a := xi2; p2^.o := yi2; p2^.urm := q2^.urm;
      if (xi1 = q1^.a) and (yi1 = q1^.o) then
         p1 := q1
         else
         begin
         new (p1); p1^. a := xi1; p1^.o := yi1; q1^.urm := p1;
         end;
      p1^.urm := p2;
      end
      else
      begin
      {retin partea "din dreapta"}
      new (p1); p1^.a := xi1; p1^.o := yi1; p1^. urm:= q1 ^. urm;
      if (xi2 = q2^.a) and (yi2 = q2^.o) then
         p2 := q2
         else
         begin
         new (p2); p2^.a := xi2; p2^.o := yi2; q2^.urm := p2;
         end;
      p2^.urm := p1;
      end;
   p := p1;
   end
end;

begin {program principal}
citire;
write('fisier iesire : ');
readln(nume);
assign (fout,nume); rewrite (fout);
for i := 1 to n do
    begin
    {construiesc poligonul Voronoi corespunzator postului Pi}
    p := InitPoligon;
    for j := 1 to n do
        if i <> j then
           {determin punctele de intersectie ale poligonului cu mediatoarea segmentului (Pi, Pj)
           retin intersectia poligonului cu semiplanul S(i, j)}
           Intersect (p, i, j);
    writeln (fout, Arie (p): 10:2);
    end;
close (fout);
end.








