#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int far msum[150][150];

unsigned char pnext[150][150], psz[150];
unsigned char gr[150];
unsigned char queue[150];
int pi[150];

#define NOSUM							0x7fff

void do_bf(int n) {
	int qin, qout;
	int cv, x;

	for(x = 0; x < n; x++) {
		if(!gr[x])
			break;
	}
	queue[0] = x;
	qin = 1; qout = 0;

	while(qin != qout) {
		cv = queue[qout++];
		for(x = 0; x < psz[cv]; x++)
			queue[qin++] = pnext[cv][x];
	}
}

void calc_sums(int n) {
	int z, x, y, k;
	int vz, vy;

	memset(pi, 0xff, sizeof(pi));

	for(z = n - 1; z >= 0; z--) {
		msum[queue[z]][0] = 0;
		for(x = 1; x < n; x++)
			msum[queue[z]][x] = 0x7fff;


		msum[queue[z]][1] = psz[queue[z]];
		if(!psz[queue[z]])
			continue;

		vz = queue[z];
		for(y = 0; y < psz[vz]; y++) {
			vy = pnext[vz][y];
			for(x = 1; x < n; x++) {
				if(msum[vz][x] == NOSUM)
					continue;

				for(k = n - x - 2; k > 0; k--) {
					if(msum[vz][x + k] > msum[vz][x] + msum[vy][k] - 1 &&
													pi[x] != vy && msum[vy][k] != NOSUM) {
						msum[vz][x + k] = msum[vz][x] + msum[vy][k] - 1;
						pi[x + k] = vy;
					}
				}
			}
		}
	}
}

int main() {
	FILE *fp;
	int n, k;
	int x;
	int t0, t1;
	int ms, cs;

	memset(psz, 0, sizeof(psz));
	memset(gr, 0, sizeof(gr));

	fp = fopen("arbore.in", "rt");
	fscanf(fp, "%d%d", &n, &k);
	for(x = 1; x < n; x++) {
		fscanf(fp, "%d%d", &t0, &t1);
		t0--; t1--;
		pnext[t0][psz[t0]++] = t1;
		gr[t1]++;
	}
	fclose(fp);

	do_bf(n);
	if(k == 1)
		ms = 1;
	else if(k == n)
		ms = 0;
	else {
		calc_sums(n);
		ms = 0x7fff;
		for(x = 0; x < n; x++) {
			if(msum[x][k] == NOSUM)
				continue;

			if(gr[x])
				cs = msum[x][k] + 1;
			else
				cs = msum[x][k];
			if(cs < ms)
				ms = cs;
		}
	}


	fp = fopen("arbore.out", "wt");
	fprintf(fp, "%d\n", ms);
	fclose(fp);

	return 0;
}