#include <stdio.h>

const int NMax = 100;
const int KMax = 100;

const int NP   = 25;
const int P[]  = {0,2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97};

struct Huge
{
	int n;
	int c[50];
};

int  N, K;
Huge H;


void ReadData()
{
	FILE* f = fopen("exp.in", "rt");
	fscanf(f, "%d %d", &N, &K);
	fclose(f);
}

void Prod(Huge& h, int r[])
{
	int i;

	for (i = 1; i < 50; i++) h.c[i] = 0;
	h.n = 1;
	h.c[1] = 1;

	for (i = 1; i <= NMax; i++)
		while (r[i] > 0)
		{
			int rr = 0;
			for (int j = 1; j <= h.n; j++)
			{
				h.c[j] = h.c[j] * i + rr;
				rr = h.c[j] / 10;
				h.c[j] = h.c[j] % 10;
			}
			while (rr > 0)
			{
				h.c[++h.n] = rr % 10;
				rr /= 10;
			}
			r[i]--;
		}
}

void Sum(Huge& h, Huge& t)
{
	int r = 0;
	for (int i = 1; i <= h.n; i++)
	{
		h.c[i] += t.c[i] + r;
		r = h.c[i] / 10;
		h.c[i] = h.c[i] % 10;
	}
}

void Solve()
{
	int  i, j, t, k;
	int  NF[NMax+1], KF[NMax+1], NKF[NMax+1], R[NMax+1];
	Huge T;

	H.n = 50;

	for (i = 0; i <= NMax; i++)
		NF[i] = KF[i] = NKF[i] = 0;

	// Prepare
	N -= 2;
	if (K > N) K = N;

	for (i = 1; i <= N; i++)
	{
		t = i;
		for (j = 1; (j <= NP) && (t != 1); j++)
			while (t % P[j] == 0)
			{
				NF [P[j]]++;
				NKF[P[j]]++;
				t /= P[j];
			}
	}

	// Compute
	for (k = 0; k <= K; k++)
	{
		for (i = 0; i <= NMax; i++)
			R[i] = NF[i] - KF[i] - NKF[i];

		Prod(T, R);
		Sum(H, T);

		if (k < K)
		{
			t = k+1;
			for (j = 1; (j <= NP) && (t != 1); j++)
				while (t % P[j] == 0)
				{
					KF[P[j]]++;
					t /= P[j];
				}

			t = N-k;
			for (j = 1; (j <= NP) && (t != 1); j++)
				while (t % P[j] == 0)
				{
					NKF[P[j]]--;
					t /= P[j];
				}
		}
	}
}

void WriteData()
{
	FILE* f = fopen("exp.out", "wt");
	while (H.c[H.n] == 0) H.n--;
	for (int i = H.n; i >= 1; i--)
		fprintf(f, "%d", H.c[i]);
	fprintf(f, "\n");
	fclose(f);
}


void main()
{
	ReadData();
	Solve();
	WriteData();
}