#pragma option -3 -r -Z -O2 -a
#include <stdio.h>

const int t[7][7][7][7];

int a[128][128], xi, xj, cnt;

void fill_row(int i, int j, int n)
{
	for(; n; n -= 2, j += 2) {
		a[i][j] = a[i + 1][j] = a[i][j + 1] = ++cnt;
		a[i + 2][j] = a[i + 2][j + 1] = a[i + 1][j + 1] = ++cnt;
		a[i + 3][j] = a[i + 4][j] = a[i + 3][j + 1] = ++cnt;
		a[i + 5][j] = a[i + 5][j + 1] = a[i + 4][j + 1] = ++cnt;
	}
}

void fill_col(int i, int j, int n)
{
	for(; n; n -= 2, i += 2) {
		a[i][j] = a[i + 1][j] = a[i][j + 1] = ++cnt;
		a[i + 1][j + 1] = a[i + 1][j + 2] = a[i][j + 2] = ++cnt;
		a[i][j + 3] = a[i + 1][j + 3] = a[i][j + 4] = ++cnt;
		a[i + 1][j + 4] = a[i + 1][j + 5] = a[i][j + 5] = ++cnt;
	}
}

void ins_const(int bi, int bj, const int t[7][7])
{
	int i, j;

	for(i = 0; i < 7; i++)
		for(j = 0; j < 7; j++)
			if(t[i][j])
				a[bi + i][bj + j] = t[i][j] + cnt;
	cnt += 16;
}

void back(int bi, int bj, int n)
{
	if(n == 7)
		goto solve;
	if((bi + 5 < xi) && (bj + 5 < xj)) {
		back(bi + 6, bj + 6, n - 6);
		fill_row(bi, bj + 7, n - 7);
		fill_col(bi + 7, bj, n - 7);
		xi = bi + 6, xj = bj + 6;
		goto solve;
	}
	if((bi + n - 6 > xi) && (bj + n - 6 > xj)) {
		back(bi, bj, n - 6);
		fill_row(bi + n - 6, bj, n - 7);
		fill_col(bi, bj + n - 6, n - 7);
		xi = bi += n - 7, xj = bj += n - 7;
		goto solve;
	}
	if((bi + n - 6 > xi) && (bj + 5 < xj)) {
		back(bi, bj + 6, n - 6);
		fill_row(bi + n - 6, bj + 7, n - 7);
		fill_col(bi, bj, n - 7);
		xi = bi += n - 7, xj = bj + 6;
		goto solve;
	}
	back(bi + 6, bj, n - 6);
	fill_row(bi, bj, n - 7);
	fill_col(bi + 7, bj + n - 6, n - 7);
	xi = bi + 6, xj = bj += n - 7;
solve:
	ins_const(bi, bj, t[xi - bi][xj - bj]);
}

int main()
{
	int n, i, j;

	fscanf(fopen("patrat.in", "r"), "%d%d%d", &n, &xi, &xj);
	n = n * 6 + 1;
	xi--, xj--;
	back(0, 0, n);
	freopen("patrat.out", "w", stdout);
	for(i = 0; i < n; i++, putchar('\n'))
		for(j = 0; j < n; j++)
			printf("%-5d", a[i][j]);
	return(0);
}

const int t[7][7][7][7] = {
{
  { /* (1,1) */
    {  0,  1,  2,  2,  3,  4,  4  },
    {  5,  1,  1,  2,  3,  3,  4  },
    {  5,  5,  6,  7,  7,  8,  8  },
    {  9,  9,  6,  6,  7,  8, 10  },
    {  9, 11, 11, 12, 12, 10, 10  },
    { 13, 11, 14, 12, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (1,2) */
    {  1,  0,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  2,  3,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (1,3) */
    {  1,  1,  0,  2,  3,  4,  4  },
    {  1,  5,  2,  2,  3,  3,  4  },
    {  6,  5,  5,  7,  7,  8,  8  },
    {  6,  6,  9,  7, 10, 10,  8  },
    { 11, 11,  9,  9, 10, 12, 12  },
    { 11, 13, 14, 15, 15, 12, 16  },
    { 13, 13, 14, 14, 15, 16, 16  }
  },
  { /* (1,4) */
    {  1,  2,  2,  0,  3,  4,  4  },
    {  1,  1,  2,  5,  3,  3,  4  },
    {  6,  7,  7,  5,  5,  8,  8  },
    {  6,  6,  7,  9,  9,  8, 10  },
    { 11, 11, 12, 12,  9, 10, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (1,5) */
    {  1,  2,  2,  3,  0,  4,  4  },
    {  1,  1,  2,  3,  3,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (1,6) */
    {  1,  2,  2,  3,  3,  0,  4  },
    {  1,  1,  2,  3,  5,  4,  4  },
    {  6,  6,  7,  7,  5,  5,  8  },
    {  6,  9,  7, 10, 10,  8,  8  },
    {  9,  9, 11, 11, 10, 12, 12  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (1,7) */
    {  1,  2,  2,  3,  4,  4,  0  },
    {  1,  1,  2,  3,  3,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  }
},
{
  { /* (2,1) */
    {  1,  1,  2,  3,  3,  4,  4  },
    {  0,  1,  2,  2,  3,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (2,2) */
    {  1,  1,  2,  3,  3,  4,  4  },
    {  1,  0,  2,  2,  3,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (2,3) */
    {  1,  1,  2,  2,  3,  4,  4  },
    {  1,  5,  0,  2,  3,  3,  4  },
    {  6,  5,  5,  7,  7,  8,  8  },
    {  6,  6,  9,  7, 10, 10,  8  },
    { 11, 11,  9,  9, 10, 12, 12  },
    { 11, 13, 14, 15, 15, 12, 16  },
    { 13, 13, 14, 14, 15, 16, 16  }
  },
  { /* (2,4) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  0,  3,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (2,5) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  0,  4,  5  },
    {  6,  7,  7,  8,  8,  5,  5  },
    {  6,  6,  7,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (2,6) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  0,  4  },
    {  6,  6,  7,  7,  5,  5,  8  },
    {  6,  9,  7, 10, 10,  8,  8  },
    {  9,  9, 11, 11, 10, 12, 12  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (2,7) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  0  },
    {  6,  6,  7,  7,  5,  5,  8  },
    {  6,  9,  7, 10, 10,  8,  8  },
    {  9,  9, 11, 11, 10, 12, 12  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  }
},
{
  { /* (3,1) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  0,  7,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (3,2) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  0,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (3,3) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  0,  5,  5,  6,  6  },
    {  7,  8,  9, 10, 10, 11, 11  },
    {  8,  8,  9,  9, 10, 12, 11  },
    { 13, 14, 14, 15, 12, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (3,4) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  7,  7,  0,  5,  8,  8  },
    {  6,  6,  7,  9,  9,  8, 10  },
    { 11, 11, 12, 12,  9, 10, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (3,5) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  6,  7,  7,  0,  5,  8  },
    {  6,  9,  7, 10, 10,  8,  8  },
    {  9,  9, 11, 11, 10, 12, 12  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (3,6) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  6,  7,  7,  5,  0,  8  },
    {  6,  9,  7, 10, 10,  8,  8  },
    {  9,  9, 11, 11, 10, 12, 12  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (3,7) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  6,  7,  7,  5,  8,  0  },
    {  6,  9,  7, 10, 10,  8,  8  },
    {  9,  9, 11, 11, 10, 12, 12  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  }
},
{
  { /* (4,1) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  8,  5,  5,  6,  6  },
    {  0,  7,  8,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (4,2) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  8,  5,  5,  6,  6  },
    {  7,  0,  8,  8,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (4,3) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  6,  7,  7,  5,  8,  8  },
    {  6,  9,  0,  7, 10,  8, 11  },
    {  9,  9, 12, 10, 10, 11, 11  },
    { 13, 12, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (4,4) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  0,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  9, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (4,5) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9,  0, 10, 10  },
    { 11, 11,  9,  9, 12, 12, 10  },
    { 11, 13, 14, 15, 15, 12, 16  },
    { 13, 13, 14, 14, 15, 16, 16  }
  },
  { /* (4,6) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9,  9,  0, 10  },
    { 11, 11, 12, 12,  9, 10, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (4,7) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 10,  0  },
    { 11, 11,  9,  9, 10, 12, 12  },
    { 11, 13, 14, 15, 15, 12, 16  },
    { 13, 13, 14, 14, 15, 16, 16  }
  }
},
{
  { /* (5,1) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    {  0, 12,  9,  9, 10, 10, 11  },
    { 13, 12, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (5,2) */
    {  1,  1,  2,  3,  3,  4,  4  },
    {  1,  5,  2,  2,  3,  4,  6  },
    {  5,  5,  7,  8,  8,  6,  6  },
    {  9,  9,  7,  7,  8, 10, 10  },
    {  9,  0, 11, 11, 12, 12, 10  },
    { 13, 14, 14, 11, 15, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (5,3) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9,  9, 10, 10  },
    { 11, 11,  0,  9, 12, 12, 10  },
    { 11, 13, 14, 15, 15, 12, 16  },
    { 13, 13, 14, 14, 15, 16, 16  }
  },
  { /* (5,4) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  8,  5,  5,  6,  6  },
    {  7,  9,  8,  8, 10, 11, 11  },
    {  9,  9, 12,  0, 10, 10, 11  },
    { 13, 12, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (5,5) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  7,  7,  8,  5,  9,  9  },
    {  6,  6,  7,  8,  8,  9, 10  },
    { 11, 11, 12, 12,  0, 10, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (5,6) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9,  9, 10, 10  },
    { 11, 11, 12, 12,  9,  0, 10  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (5,7) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9,  9, 10, 10  },
    { 11, 11, 12, 12,  9, 10,  0  },
    { 11, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  }
},
{
  { /* (6,1) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  8,  5,  5,  6,  6  },
    {  7,  9,  8,  8, 10, 11, 11  },
    {  9,  9, 12, 12, 10, 10, 11  },
    {  0, 13, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (6,2) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  8,  5,  5,  6,  6  },
    {  7,  9,  8,  8, 10, 11, 11  },
    {  9,  9, 12, 12, 10, 10, 11  },
    { 13,  0, 12, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (6,3) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13,  0, 14, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (6,4) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14,  0, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 15, 16  }
  },
  { /* (6,5) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  5,  4  },
    {  6,  6,  7,  7,  5,  8,  8  },
    {  6,  9,  7, 10, 11, 11,  8  },
    {  9,  9, 10, 10, 11, 12, 12  },
    { 13, 14, 14, 15,  0, 12, 16  },
    { 13, 13, 14, 15, 15, 16, 16  }
  },
  { /* (6,6) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 15, 15,  0, 16  },
    { 13, 13, 14, 14, 15, 16, 16  }
  },
  { /* (6,7) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 15, 15, 16,  0  },
    { 13, 13, 14, 14, 15, 16, 16  }
  }
},
{
  { /* (7,1) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 14, 15, 16, 16  },
    {  0, 13, 13, 14, 15, 15, 16  }
  },
  { /* (7,2) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  7,  8,  5,  5,  6,  6  },
    {  7,  9,  8,  8, 10, 11, 11  },
    {  9,  9, 12, 12, 10, 10, 11  },
    { 13, 13, 12, 14, 15, 16, 16  },
    { 13,  0, 14, 14, 15, 15, 16  }
  },
  { /* (7,3) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 14, 15, 16, 16  },
    { 13, 13,  0, 14, 15, 15, 16  }
  },
  { /* (7,4) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 14, 15, 16, 16  },
    { 13, 13, 14,  0, 15, 15, 16  }
  },
  { /* (7,5) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9,  9, 10, 10  },
    { 11, 11, 12, 12,  9, 13, 10  },
    { 11, 14, 12, 15, 13, 13, 16  },
    { 14, 14, 15, 15,  0, 16, 16  }
  },
  { /* (7,6) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 15, 15, 16, 16  },
    { 13, 13, 14, 14, 15,  0, 16  }
  },
  { /* (7,7) */
    {  1,  2,  2,  3,  3,  4,  4  },
    {  1,  1,  2,  3,  5,  4,  6  },
    {  7,  8,  8,  5,  5,  6,  6  },
    {  7,  7,  8,  9, 10, 11, 11  },
    { 12, 12,  9,  9, 10, 10, 11  },
    { 12, 13, 14, 15, 15, 16, 16  },
    { 13, 13, 14, 14, 15, 16,  0  }
  }
}
};
