#include <stdio.h>
#include <mem.h>

const int NMax = 20;
const int CMax = 35;

int L, B, P,Q;

unsigned char huge C[21][21][21][CMax+1];


void ReadData()
{
	FILE* f = fopen("zero.in", "rt");
	fscanf(f, "%d %d %d %d", &L, &B, &P, &Q);
	fclose(f);
}

void Set(unsigned char huge a[], int v)
{
	memset(a, 0, sizeof(a));
	while (v)
	{
		a[++a[0]] = v % 10;
		v /= 10;
	}
}

void Copy(unsigned char huge a[], unsigned char huge b[])
{
	memcpy(a, b, sizeof(a));
}

void Add(unsigned char huge a[], unsigned char huge b[])
{
	if ((a[0] > CMax) || (b[0] > CMax))
	{
		printf("Error");
	}

	if (b[0] > a[0])
		a[0] = b[0];

	int r = 0;
	for (int i = 1; i <= a[0]; i++)
	{
		a[i] += b[i] + r;
		r = a[i] / 10;
		a[i] %= 10;
	}
	if (r) a[++a[0]] = r;
}

void Mult(unsigned char huge a[], int m)
{
	int r = 0, v;
	for (int i = 1; i <= a[0]; i++)
	{
		v = a[i] * m + r;
		a[i] = v % 10;
		r = v / 10;
	}
	while (r)
	{
		a[++a[0]] = r % 10;
		r /= 10;
	}

	if (a[0] > CMax)
	{
		printf("Error");
	}
}

void Solve()
{
	int l, k, p;

	Set(C[1][0][0], B-1);
	for (l = 2; l <= L; l++)
	{
		for (k = 0; k < l; k++)
		{
			for (p = 0; p < l; p++)
				Add(C[l][k][0], C[l-1][k][p]);
			Mult(C[l][k][0], B-1);

			if (k > 0)
			{
				for (p = 1; p <= k; p++)
					Copy(C[l][k][p], C[l-1][k][p-1]);
				Add(C[l][k][k], C[l-1][k-1][k-1]);
			}
		}
	}
}

unsigned char huge p[CMax+1];
unsigned char huge q[CMax+1];

void WriteData()
{
	int i, j;

   memset(p, 0, sizeof(p));
	memset(q, 0, sizeof(p));

	for (i = 0; i <= P; i++)
		for (j = 0; j < L; j++)
			Add(p, C[L][i][j]);
	for (i = Q; i <  L; i++)
		for (j = 0; j < L; j++)
			Add(q, C[L][i][j]);

	FILE* f = fopen("zero.out", "wt");
	for (i = p[0]; i >= 1; i--)
		fprintf(f, "%d", (int)p[i]);
	fprintf(f, "\n");
	for (i = q[0]; i >= 1; i--)
		fprintf(f, "%d", (int)q[i]);
	fprintf(f, "\n");
	fclose(f);
}

void main()
{
	ReadData();
	Solve();
	WriteData();
}