#pragma -O2 -r -3 -a -Z
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void ln_add(unsigned a[8], unsigned b[8]) {
	unsigned cf1;
	int x;

	cf1 = 0;
	for(x = 0; x < 8; x++) {
		if(a[x] + b[x] + cf1 >= 10000) {
			a[x] += b[x] + cf1 - 10000;
			cf1 = 1;
		}
		else {
			a[x] += b[x] + cf1;
			cf1 = 0;
		}
	}
}
void ln_add2(unsigned r[8], unsigned a[8], unsigned b[8]) {
	unsigned cf1;
	int x;

	cf1 = 0;
	for(x = 0; x < 8; x++) {
		if(a[x] + b[x] + cf1 >= 10000) {
			r[x] = a[x] + b[x] + cf1 - 10000;
			cf1 = 1;
		}
		else {
			r[x] = a[x] + b[x] + cf1;
			cf1 = 0;
		}
	}
}
void ln_sub(unsigned a[8], unsigned b[8]) {
	unsigned cf1;
	int x;

	cf1 = 0;
	for(x = 0; x < 8; x++) {
		if(a[x] < b[x] + cf1) {
			a[x] += 10000 - (b[x] + cf1);
			cf1 = 1;
		}
		else {
			a[x] -= b[x] + cf1;
			cf1 = 0;
		}
	}
}
#define ln_sz				(sizeof(unsigned) * 8)
void ln_mul(unsigned r[8], unsigned a[8], unsigned b[8]) {
	unsigned long cf;
	int x, y;

	memset(r, 0, ln_sz);
	for(x = 0; x < 8; x++) {
		cf = 0;
		for(y = 0; x + y < 8; y++) {
			cf += (unsigned long)a[x] * b[y] + r[x + y];
			r[x + y] = (unsigned)(cf % 10000);
			cf /= 10000;
		}
	}
}
void ln_pow(unsigned r[8], int pa, int b) {
	unsigned a[8], t[8];

	memset(a + 1, 0, ln_sz - sizeof(unsigned));
	a[0] = pa;

	memset(r + 1, 0, ln_sz - sizeof(unsigned));
	r[0] = 1;

	while(b) {
		if(b & 1) {
			ln_mul(t, r, a);
			memcpy(r, t, ln_sz);
		}
		ln_mul(t, a, a);
		memcpy(a, t, ln_sz);
		b >>= 1;
	}
}

unsigned long lpow(int a, int b) {
	unsigned long r = 1;
	unsigned long m;

	m = a;

	while(b) {
		if(b & 1)
			r *= m;
		m *= m;
		b >>= 1;
	}
	return r;
}

unsigned ctbl[24][24][8];
unsigned ptbl[24][24][8];
unsigned qtbl[24][24][8];
unsigned bminsq[8], bminus[8];
int b, l;

void calc_f(int l, int c, int p, unsigned r[8]) {
	unsigned k0[8], t0[8], t1[8];

	if(p >= 2) {
//		k0 = lpow(b, p - 2) * (b - 1) * (b - 1) - qtbl[p - 1][c] * (b - 1);
		ln_pow(t0, b, p - 2);
		ln_mul(k0, t0, bminsq);
		ln_mul(t0, qtbl[p - 1][c], bminus);
		ln_sub(k0, t0);
	}
	else {
//		k0 = b - 1;
		memcpy(k0, bminus, ln_sz);
	}

	if(l - c - p > 0) {
//		*r = k0 * ptbl[l - c - p][c];
		ln_mul(r, k0, ptbl[l - c - p][c]);
	}
	else {
//		*r = k0;
		memcpy(r, k0, ln_sz);
	}
}

void calc_g(int l, int c) {
	unsigned t0[8];
	int i;

	if(!c) {
//		ctbl[l][c] = lpow(b - 1, l);
		ln_pow(ctbl[l][c], b - 1, l);
	}
	else {
		for(i = 1; i + c <= l; i++) {
			calc_f(l, c, i, t0);
			ln_add(ctbl[l][c], t0);
		}
	}
}

void calc_v() {
	int x, y;

	for(y = 1; y <= l; y++) {
		for(x = 0; x < y; x++) {
			calc_g(y, x);
		}
//		ptbl[y][0] = ctbl[y][0];
		memcpy(ptbl[y][0], ctbl[y][0], ln_sz);
		for(x = 1; x <= l; x++) {
//			ptbl[y][x] = ptbl[y][x - 1] + ctbl[y][x];
			ln_add2(ptbl[y][x], ptbl[y][x - 1], ctbl[y][x]);
		}
//		qtbl[y][y - 1] = ctbl[y][y - 1];
		memcpy(qtbl[y][y - 1], ctbl[y][y - 1], ln_sz);
		for(x = y - 2; x >= 0; x--) {
//			qtbl[y][x] = qtbl[y][x + 1] + ctbl[y][x];
			ln_add2(qtbl[y][x], qtbl[y][x + 1], ctbl[y][x]);
		}
	}
}

unsigned *sp, *sq;

void calc_rs(int p, int q) {
	int x;

	sp = ptbl[l][p];
	sq = qtbl[l][q];
}

void ln_print(FILE *fp, unsigned n[8]) {
	int x;
	int f;

	f = 0;
	for(x = 7; x >= 0; x--) {
		if(n[x]) {
			if(f)
				fprintf(fp, "%04u", n[x]);
			else {
				fprintf(fp, "%u", n[x]);
			}
		}
	}
	fprintf(fp, "\n");
}

void print_rezs(FILE *fp) {
	ln_print(fp, sp);
	ln_print(fp, sq);
}

void calc_init() {
	unsigned t0[8], t1[8];

	memset(bminus, 0, ln_sz);
	bminus[0] = b - 1;
	ln_pow(bminsq, b - 1, 2);
}

void main() {
	FILE *fp;
	int p, q;

	fp = fopen("zero.in", "rt");
	fscanf(fp, "%d %d %d %d", &l, &b, &p, &q);
	fclose(fp);

	calc_init();
	calc_v();
	calc_rs(p, q);

	fp = fopen("zero.out", "wt");
	print_rezs(fp);
	fclose(fp);
}