#pragma -O2 -r -3 -a -Z
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int far blnk[30000];
int far rng[30000];
int far hbase[30000];
int far th[30000];

int h0_find(int w) {
	int t, t2;
	int hp, hp2;

	hp = 0;
	t = w;
	while(blnk[w] != -1) {
		hp += hbase[w];
		w = blnk[w];
	}

	while(blnk[t] != -1) {
		t2 = blnk[t];
		blnk[t] = w;
		hp2 = hp - hbase[t];
		hbase[t] = hp;
		hp = hp2;
		t = t2;
	}
	return w;
}

void fbf_merge(int v0, int v1) {
	int b0, b1;

	b0 = h0_find(v0);
	b1 = h0_find(v1);
	if(rng[b0] > rng[b1]) {
		blnk[b1] = b0;
		hbase[b0] += th[b1];
		hbase[b1] -= hbase[b0];
		th[b0] += th[b1];
	}
	else if(rng[b0] < rng[b1]) {
		blnk[b0] = b1;
		hbase[b0] += th[b1] - hbase[b1];
		th[b1] += th[b0];
	}
	else {
		blnk[b0] = b1;
		hbase[b0] += th[b1] - hbase[b1];
		th[b1] += th[b0];
		rng[b0]++;
	}
}
int fbf_find(int w) {
	int t;

	t = h0_find(w);
	return hbase[w] + hbase[t];
}

char fbuf[128];

void main() {
	FILE *fp, *fpout;
	int t0, t1;
	int x;

	_fmemset(blnk, -1, sizeof(blnk));

	for(x = 0; x < 30000; x++)
		th[x] = 1;

	fp = fopen("cuburi.in", "rt");
	fpout = fopen("cuburi.out", "wt");
	while(1) {
		if(!fgets(fbuf, 120, fp))
			break;
		if(sscanf(fbuf, "P%d%d", &t0, &t1) == 2) {
			fbf_merge(t0 - 1, t1 - 1);
		}
		else if(sscanf(fbuf, "S%d", &t0) == 1) {
			fprintf(fpout, "%d\n", fbf_find(t0 - 1));
		}
		else
			break;
	}
	fclose(fp);
	fclose(fpout);
}