#include <stdio.h>

#define infile "trenuri.in"
#define outfile "trenuri.out"

#define max_n 1001

int n;
double a,b;
double v[max_n],d[max_n],s[max_n],t[max_n];

void read_data()
{
  FILE *f;
  int i;

  f=fopen(infile,"rt");

  fscanf(f,"%i",&n);
  fscanf(f,"%lf",&a);

  for (i=1;i<n;i++)
    fscanf(f,"%lf%lf%lf\n",&v[i],&s[i],&d[i]);

  fscanf(f,"%lf%lf",&v[n],&s[n]);

  fclose(f);
}

void calc_times()
{
  int i;

  t[0]=0;
  s[0]=0;

  for (i=1;i<=n;i++)
    t[i]=t[i-1]+d[i-1]+(s[i]-s[i-1])/v[i];
}

double get_t1(double s0)
{
  int i;

  if (s[0]>=s0) return 0;

  for (i=0;i<n;i++)
    if (s[i+1]>=s0) break;

  if (i==n) return t[n];

  return ((s0-s[i])/(s[i+1]-s[i]))*(t[i+1]-t[i]-d[i])+t[i]+d[i];
}

double get_t2(double s0)
{
  int i;

  if (s[0]>=s0) return 0;

  for (i=0;i<n;i++)
    if (s[i+1]>s0) break;

  if (i==n) return t[n];

  return ((s0-s[i])/(s[i+1]-s[i]))*(t[i+1]-t[i]-d[i])+t[i]+d[i];
}

double solve1()
{
  int i;
  double b1=0,t1;

  for (i=0;i<=n;i++)
  {
    t1=get_t1(s[i]+a);
    if (t1-t[i]>b1) b1=t1-t[i];
  }

  return b1;
}

double solve2()
{
  int i;
  double b2=0,t2;

  for (i=0;i<=n;i++)
  {
    t2=get_t2(s[i]-a);
    if (t[i]+d[i]-t2>b2) b2=t[i]+d[i]-t2;
  }

  return b2;
}

void proc_data()
{
  double b1,b2;

  calc_times();

  b1=solve1();
  b2=solve2();

  if (b1>b2) b=b1; else b=b2;
}

void save_data()
{
  FILE *f;

  f=fopen(outfile,"wt");

  fprintf(f,"%.2f",b);

  fclose(f);
}

int main()
{
  read_data();
  proc_data();
  save_data();

  return 0;
}