/* Cuburi: Solutia banala:
   - PUNE() implementata in O(N)
   - SUB() implementata in O(N)
   Metoda: Vectorul under[i] indica ce cub se afla sub cubul i
           Vectorul on[i] indica ce cub se afla peste cubul i
   Intrare: cuburi.in. Iesire: cuburi.out
*/

#include <dos.h>
#include <mem.h>
#include <stdio.h>

FILE *fin, *fout;
int huge under[30001], huge on[30001];

void initdata(void)
{ /* Citeste N si initializeaza vectorul de cuburi */
  fin=fopen("cuburi.in", "r");
  fout=fopen("cuburi.out", "w");
  memset(under, 0, sizeof(under)); /* sub nici un cub nu se afla nimic */
  memset(on, 0, sizeof(on)); /* peste nici un cub nu se afla nimic */
}

void pune(void)
{
  int x, y;

  fscanf(fin, "%d %d", &x, &y);
  /* Baza turnului lui x trebuie pusa in varful turnului lui y */
  while (under[x]) x=under[x];
  while (on[y]) y=on[y];
  under[x]=y; on[y]=x;
}

int sub(void)
{
  int z, h;
  fscanf(fin, "%d", &z);
  h=0;
  while (under[z]) z=under[z], h++;
  return h;
}

int main(void)
{
  char s[3];
  long *time=(long *)MK_FP(0, 0x046C);
  long t0=*time;

  initdata();
  while (fscanf(fin, "%s", s)==1)
    if (s[0]=='P') pune();
    else fprintf(fout, "%d\n", sub());
  fclose(fin); fclose(fout);
  printf("Am rulat %.3f secunde.\n", 0.055*(*time-t0));
  return 0;
}
