/* Cuburi: Solutia eficienta:
   - PUNE() implementata in O(log*N)
   - SUB() implementata in O(log*N)
   Metoda: Structura de multimi disjuncte (vezi explicatia MS Word)
   Intrare: cuburi.in. Iesire: cuburi.out
*/

#include <dos.h>
#include <stdio.h>

FILE *fin, *fout;
int huge size[30001], huge height[30001], huge link[30001];

void initdata(void)
{ /* Citeste N si initializeaza vectorul de cuburi */
  int i;
  fin=fopen("cuburi.in", "r");
  fout=fopen("cuburi.out", "w");

  for (i=1; i<=30000; i++)
    {
      size[i]=1; height[i]=link[i]=0;
    }
}

void compress(int x)
{
  int root=x, h=0;
  while (link[root])
    h+=height[root], root=link[root];
  while (x!=root)
    {
      height[x]=h; link[x]=root;
      h-=height[x], x=link[x];
    }
}

void pune(void)
{
  int x, y;
  fscanf(fin, "%d %d", &x, &y);
  compress(x); compress(y);
  while (link[x]) x=link[x];
  while (link[y]) y=link[y];
  link[x]=y;
  height[x]=size[y];
  size[y]+=size[x];
}

int sub(void)
{
  int z;
  fscanf(fin, "%d %d", &z);
  compress(z);
  return height[z];
}

int main(void)
{
  char s[3];
  long *time=(long *)MK_FP(0, 0x046C);
  long t0=*time;

  initdata();
  while (fscanf(fin, "%s", s)==1)
    if (s[0]=='P') pune();
    else fprintf(fout, "%d\n", sub());
  fclose(fin); fclose(fout);
  printf("Am rulat %.3f secunde.\n", 0.055*(*time-t0));
  return 0;
}
