#include <mem.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

long n, m;
int links[30001], connected=0;

void init(void)
{
  randomize();
  memset(links, 0, sizeof(links));
}

int group(int x)
{
  int root=x, tmp;
  while (links[root]) root=links[root];
  while (x!=root)
    {
      tmp=links[x];
      links[x]=root;
      x=tmp;
    }
  return root;
}

void join(int x, int y)
{
  links[group(x)]=group(y);
}

void pune(void)
{
  int x=1+rand()%n, y;
  do { y=1+rand()%n; }
  while (group(x)==group(y));
  printf("P %d %d\n", x, y);
  join(x, y);
  connected++;
}

void sub(void)
{
  printf("S %d\n", 1+rand()%n);
}

void output(void)
{
  long i;
  for (i=1; i<=m; i++)
    if (random(m)<n && connected<n-1)
      pune();
    else sub();
}

int main(int argc, char **argv)
{
  if (argc!=3)
    {
      printf("Usage: %s <N> <M>\n", argv[0]);
      return 1;
    }
  init();
  n=atol(argv[1]);
  m=atol(argv[2]);
  output();
  return 0;
}
